/**
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeHandleInt.java,v 1.3 2002/01/31 16:39:04 schmerl Exp $
 * $Log: RMIGaugeHandleInt.java,v $
 * Revision 1.3  2002/01/31 16:39:04  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;
/**
 * RMIGaugeHandleInt is the interface of RMIGaugeHandle
 * @see         GaugeHandle
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 */
public interface RMIGaugeHandleInt extends java.rmi.Remote
{

    public RMIGauge getGauge() throws java.rmi.RemoteException;
    public StringPairVector getConfigParams() throws java.rmi.RemoteException;
    public int getConfigParamsSize() throws java.rmi.RemoteException;    
    public StringPairVector getSetupParams() throws java.rmi.RemoteException;
    public int getSetupParamsSize() throws java.rmi.RemoteException;    
    public void delete() throws java.rmi.RemoteException;
            
    public boolean configure(StringPairVector configParams) throws java.rmi.RemoteException;
    
    public boolean queryAllValues(GaugeValueVector values) throws java.rmi.RemoteException;
    
    public boolean queryState(StringPairVector setupParams, StringPairVector configParams, StringPairVector mappings) throws java.rmi.RemoteException;
    
    public String queryValue(String valueName) throws java.rmi.RemoteException;
    
    public GaugeID getGaugeID() throws java.rmi.RemoteException;
}
