/**
 * RMIGaugeMgr.java
 * @author      Hong Yan
 * @author      Bradley Schmerl
 * @version     1.0
 * @since       JDK1.3.1
 * $Header: D:/Projects/Repository/GaugeAPI/edu/cmu/cs/able/gaugeInfrastructure/RMI/RMIGaugeMgr.java,v 1.3 2002/01/31 16:39:05 schmerl Exp $
 * $Log: RMIGaugeMgr.java,v $
 * Revision 1.3  2002/01/31 16:39:05  schmerl
 * Added CVS header information
 *
 */

package edu.cmu.cs.able.gaugeInfrastructure.RMI;

import java.util.Vector;
import java.util.Enumeration;


import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.Events.*;


public class RMIGaugeMgr implements GaugeMgr, java.io.Serializable
{
    protected RMIGaugeReportingBus gaugeBus;
    protected String gaugeMgrUID = null;
    protected String gaugeMgrType = null;
    protected static String busHost = "localhost:1099";
    
    /**
    * Constructor of RMIGaugeMgr
    */
    public RMIGaugeMgr(String host)
    {
        super();
        //Initialization.startGaugeMgrService(this);
        try {
            gaugeBus = new RMIGaugeReportingBus (host);                 
            //gaugeBus.registerGaugeMgr("GaugeMgr");
            //createGauge(null, null, null);
        }
        catch (Exception e) {}
    }

    public String getGaugeMgrID()
    {
        return gaugeMgrUID;
    }

    public String getGaugeMgrType()
    {
        return gaugeMgrType;
    }
    
    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings)
    {
        /*Global.exec("java -classpath ../../../../../../gaugeInfrastructureRMI.jar;../../gauges/RMI/ RMIBWGauge -gn RMIBWGaugeName -gt RMIBWGauge -mn RMIBWGaugeModelName -mt RMIBWGaugeModelType");
        RMIGaugeHandle gh = new RMIGaugeHandle(Global.getHost()+":1299");
        return gh;*/
        return null;
    }
    
    
    public boolean managesType(String gaugeType)
    {
        return true;
    }
    
    
    public boolean deleteGauge(GaugeControl gauge)
    {
        System.out.println("try to delete gauge:"+gauge.getGaugeID().toString());
        return true;
    }
    
    
    public boolean queryMetaInfo(String gaugeType, StringPairVector configParamsMeta, StringPairVector valuesMeta)
    {
        return true;
    }
}
